Index: palm/trunk/INSTALL/test_oceanml_p3d
===================================================================
--- palm/trunk/INSTALL/test_oceanml_p3d	(revision 3274)
+++ palm/trunk/INSTALL/test_oceanml_p3d	(revision 3275)
@@ -1,45 +1,85 @@
+!-------------------------------------------------------------------------------
+!-- INITIALIZATION PARAMETER NAMELIST
+!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/inipar
+!-------------------------------------------------------------------------------
 &initialization_parameters
-        nx = 63, ny = 63, nz=64,
-        dx = 1.25, dy = 1.25, dz = 1.25,
+!
+!-- grid parameters
+!-------------------------------------------------------------------------------
+    nx                         = 63, ! Number of gridboxes in x-direction (nx+1)
+    ny                         = 63, ! Number of gridboxes in y-direction (ny+1)
+    nz                         = 64, ! Number of gridboxes in z-direction (nz)
 
-        fft_method = 'temperton-algorithm',
+    dx                         = 1.25, ! Size of single gridbox in x-direction
+    dy                         = 1.25, ! Size of single gridbox in y-direction
+    dz                         = 1.25, ! Size of single gridbox in z-direction
+!
+!-- initialization
+!-------------------------------------------------------------------------------
+    initializing_actions       = 'set_constant_profiles', ! initial conditions
 
-        ocean = .T.,
+    ocean                      = .TRUE., ! enable ocean modeling
+    latitude                   = 55.6,
 
-        initializing_actions = 'set_constant_profiles',
+    ug_surface                 = 0.0, ! u-comp of geostrophic wind at surface
+    vg_surface                 = 0.0, ! v-comp of geostrophic wind at surface
+
+    pt_surface                 = 300.0, ! initial surface potential temp
+!
+!-- boundary conditions
+!-------------------------------------------------------------------------------
+    bc_uv_b                    = 'neumann',
+    bc_uv_t                    = 'neumann',
+    bc_pt_b                    = 'neumann',
+    bc_pt_t                    = 'neumann',
+    bc_p_b                     = 'neumann',
+    bc_p_t                     = 'neumann',
+    bc_s_b                     = 'initial_gradient',
+    bc_s_t                     = 'neumann',
+    bc_sa_t                    = 'neumann',
+
+    use_top_fluxes             = .T.,
+    use_surface_fluxes         = .F.,
+    constant_flux_layer        = .F.,
+
+    top_momentumflux_u         = -0.0001,
+    top_momentumflux_v         = 0.0,
+
+    top_heatflux               = 0.0,
+    top_salinityflux           = 0.0,
+!
+!-- numerics
+!-------------------------------------------------------------------------------
+    fft_method                 = 'temperton-algorithm',   ! build-in fft method
+
+    momentum_advec             = 'pw-scheme', ! use Piacsek and Williams scheme
+    scalar_advec               = 'pw-scheme', ! use Piacsek and Williams scheme
+
+/ ! end of initialization parameter namelist
+
+!-------------------------------------------------------------------------------
+!-- RUNTIME PARAMETER NAMELIST
+!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/d3par
+!-------------------------------------------------------------------------------
+&runtime_parameters
+!
+!-- run steering
+!-------------------------------------------------------------------------------
+    end_time                   = 300.0, ! simulation time of the 3D model
+
+    create_disturbances        = .TRUE.,  ! randomly perturbate horiz. velocity
+    dt_disturb                 = 60.0,    ! interval for random perturbations
+    disturbance_energy_limit   = 1.0e-4,  ! upper limit for perturbation energy
+    disturbance_amplitude      = 0.25e-1, ! maximum perturbation amplitude
+!
+!-- data output
+!-------------------------------------------------------------------------------
+    netcdf_data_format         = 5, ! use NetCDF3
+
+    dt_run_control             = 0.0,    ! output interval for run control
+
+    data_output_pr             = 'e','e*', '#pt',
+
+/ ! end of runtime parameter namelist
  
-        latitude = 55.6,
-           
-        momentum_advec = 'pw-scheme',
-        scalar_advec = 'pw-scheme', 
 
-        ug_surface =0.0, vg_surface = 0.0,
-        pt_surface                 = 300.0,
-
-        use_top_fluxes= .T.,
-        use_surface_fluxes = .F.,
-        constant_flux_layer= .F.,
-        
-        top_momentumflux_u = -0.0001,
-        top_momentumflux_v = 0.0,
-        
-        top_heatflux = 0.0,
-        top_salinityflux = 0.0,
-
-        bc_uv_b = 'neumann', bc_uv_t = 'neumann', 
-        bc_pt_b = 'neumann', bc_pt_t = 'neumann',
-        bc_p_b  = 'neumann', bc_p_t  = 'neumann',
-        bc_s_b  = 'initial_gradient', bc_s_t  = 'neumann',
-        bc_sa_t = 'neumann', /
-
-&runtime_parameters
-        end_time = 300.0,
-        create_disturbances = .T.,
-        dt_disturb = 60.0,
-        disturbance_energy_limit = 1.0e-4,
-        disturbance_amplitude = 0.25e-1,
-        dt_run_control = 0.0,
-
-        data_output_pr = 'e','e*', '#pt',  /
-       
-