Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 3274)
+++ palm/trunk/SOURCE/Makefile	(revision 3294)
@@ -25,4 +25,8 @@
 # -----------------
 # $Id$
+# changes related to modularization of the ocean mode,
+# bugfix: dependency to advec_ws was missed in chemistry_model_mod
+# 
+# 3274 2018-09-24 15:42:55Z knoop
 # Added palm dependency of multi_agent_system_mod, because of mas_last_actions
 # call at the end of palm run
@@ -494,5 +498,4 @@
 	disturb_field.f90 \
 	disturb_heatflux.f90 \
-	eqn_state_seawater.f90 \
 	exchange_horiz_2d.f90 \
 	exchange_horiz.f90 \
@@ -509,9 +512,9 @@
 	init_grid.f90 \
 	init_masks.f90 \
-	init_ocean.f90 \
 	init_pegrid.f90 \
 	init_pt_anomaly.f90 \
 	init_rankine.f90 \
 	init_slope.f90 \
+	init_vertical_profiles.f90 \
 	interaction_droplets_ptq.f90 \
 	land_surface_model_mod.f90 \
@@ -548,4 +551,5 @@
 	netcdf_data_input_mod.f90 \
 	netcdf_interface_mod.f90 \
+	ocean_mod.f90 \
 	outflow_turbulence.f90 \
 	package_parin.f90 \
@@ -707,4 +711,5 @@
 	mod_kinds.o \
 	modules.o \
+	ocean_mod.o \
 	radiation_model_mod.o \
 	turbulence_closure_mod.o \
@@ -753,4 +758,5 @@
 	chemistry_model_mod.o \
 	gust_mod.o \
+	init_vertical_profiles.o \
 	land_surface_model_mod.o \
 	large_scale_forcing_nudging_mod.o \
@@ -760,4 +766,5 @@
 	netcdf_data_input_mod.o \
 	netcdf_interface_mod.o \
+	ocean_mod.o \
 	plant_canopy_model_mod.o \
 	pmc_interface_mod.o \
@@ -772,4 +779,5 @@
 	wind_turbine_model_mod.o
 chemistry_model_mod.o: \
+	advec_ws.o \
 	chem_gasphase_mod.o \
 	chem_modules.o \
@@ -867,4 +875,5 @@
 	modules.o \
 	netcdf_interface_mod.o \
+	ocean_mod.o \
 	radiation_model_mod.o \
 	surface_mod.o \
@@ -882,4 +891,5 @@
 	modules.o \
 	netcdf_interface_mod.o \
+	ocean_mod.o \
 	turbulence_closure_mod.o \
 	urban_surface_mod.o
@@ -914,8 +924,4 @@
 	modules.o \
 	random_generator_parallel_mod.o \
-	surface_mod.o
-eqn_state_seawater.o: \
-	mod_kinds.o \
-	modules.o \
 	surface_mod.o
 exchange_horiz.o: \
@@ -963,4 +969,5 @@
 	modules.o \
 	netcdf_interface_mod.o \
+	ocean_mod.o \
 	plant_canopy_model_mod.o \
 	pmc_handle_communicator_mod.o \
@@ -993,4 +1000,5 @@
 	netcdf_data_input_mod.o \
 	netcdf_interface_mod.o \
+	ocean_mod.o \
 	plant_canopy_model_mod.o \
 	pmc_interface_mod.o \
@@ -1030,9 +1038,4 @@
 	modules.o \
 	netcdf_interface_mod.o
-init_ocean.o: \
-	basic_constants_and_equations_mod.o \
-	eqn_state_seawater.o \
-	mod_kinds.o \
-	modules.o
 init_pegrid.o: \
 	mod_kinds.o \
@@ -1052,4 +1055,7 @@
 	mod_kinds.o \
 	modules.o
+init_vertical_profiles.o: \
+	modules.o \
+	mod_kinds.o
 interaction_droplets_ptq.o: \
 	basic_constants_and_equations_mod.o \
@@ -1238,4 +1244,5 @@
 	mod_kinds.o \
 	modules.o \
+	ocean_mod.o \
 	radiation_model_mod.o \
 	spectra_mod.o \
@@ -1243,4 +1250,15 @@
 	urban_surface_mod.o \
 	uv_exposure_model_mod.o
+ocean_mod.o: \
+ advec_s_pw.o \
+	advec_s_up.o \
+	advec_ws.o \
+	basic_constants_and_equations_mod.o \
+	diffusion_s.o \
+	init_vertical_profiles.o \
+	mod_kinds.o \
+	modules.o \
+	pmc_interface_mod.o \
+	user_actions.o
 outflow_turbulence.o: \
 	cpulog_mod.o \
@@ -1278,4 +1296,5 @@
 	multi_agent_system_mod.o \
 	netcdf_interface_mod.o \
+	ocean_mod.o \
 	plant_canopy_model_mod.o \
 	pmc_interface_mod.o \
@@ -1387,5 +1406,4 @@
 	diffusion_v.o \
 	diffusion_w.o \
-	eqn_state_seawater.o \
 	large_scale_forcing_nudging_mod.o \
 	mod_kinds.o \
@@ -1393,4 +1411,5 @@
 	modules.o \
 	modules.o \
+	ocean_mod.o \
 	plant_canopy_model_mod.o \
 	radiation_model_mod.o \
@@ -1508,4 +1527,5 @@
 	mod_kinds.o \
 	modules.o \
+ ocean_mod.o \
 	pmc_interface_mod.o \
 	turbulence_closure_mod.o \
@@ -1538,4 +1558,5 @@
 	modules.o \
 	multi_agent_system_mod.o \
+ ocean_mod.o \
 	pmc_interface_mod.o \
 	prognostic_equations.o \
@@ -1595,4 +1616,5 @@
 	mod_particle_attributes.o \
 	modules.o \
+ ocean_mod.o \
 	plant_canopy_model_mod.o \
 	pmc_interface_mod.o \
@@ -1785,4 +1807,5 @@
 	modules.o \
 	netcdf_interface_mod.o \
+	ocean_mod.o \
 	radiation_model_mod.o \
 	random_function_mod.o \