Index: palm/trunk/SCRIPTS/palmbuild
===================================================================
--- palm/trunk/SCRIPTS/palmbuild	(revision 3311)
+++ palm/trunk/SCRIPTS/palmbuild	(revision 3312)
@@ -100,26 +100,26 @@
 
 
-
-    # ERROR HANDLING
-    # IN CASE OF EXIT:
+    # ERROR HANDLING IN CASE OF EXIT
  trap 'rm -rf  ${source_path}/${configuration_identifier}_last_make_protocol
-       if [[ $locat != normal ]]
-       then
-          printf "\n\n +++ palmbuild killed \n\n"
+       if [[ $locat != normal  &&  $locat != control_c ]]
+       then
+          printf "\n\n+++ palmbuild crashed \n\n"
           exit 1
+       elif [[ $locat != normal ]]
+       then
+          printf "\n+++ palmbuild killed by \"^C\" \n\n"
+          exit 2
        else
           if [[ $silent = false ]]
           then
-             printf "\n\n *** palmbuild finished \n\n"
+            printf "\n --> palmbuild finished\n\n"
           fi
           exit 0
-       fi
-      ' exit
-
-
-    # IN CASE OF TERMINAL-BREAK:
- trap 'printf "\n\n +++ palmbuild killed by \"^C\" \n\n"
-       rm  ${source_path}/${configuration_identifier}_last_make_protocol
-       exit
+       fi' exit
+
+
+    # ACTIONS IN CASE OF TERMINAL-BREAK (CONTROL-C):
+ trap 'locat=control_c
+       exit 1
       ' 2
 
@@ -776,6 +776,33 @@
           echo "  *** creating utilities on local host"
        fi
-       make  -f Makefile_utilities  $make_options  F90=$compiler_name  F90_SER=$compiler_name_ser  COPT="$cpp_options"  F90FLAGS="$compiler_options"  LDFLAGS="$linker_options"
-       mv agent_preprocessing $source_path/../SCRIPTS/.
+       make  -f Makefile_utilities  $make_options  F90=$compiler_name  F90_SER=$compiler_name_ser  COPT="$cpp_options"  F90FLAGS="$compiler_options"  LDFLAGS="$linker_options" | tee ${configuration_identifier}_last_make_protocol
+
+       if [[ ${PIPESTATUS[0]} != 0 ]]
+       then
+          printf "\a\n  +++ error(s) occurred during compiling of the utilities for host configuration \"$configuration_identifier\" "
+          if [[ $silent = false ]]
+          then
+             answer=dummy
+             printf "\n"
+             while [[ "$answer" != c  &&  "$answer" != k ]]
+             do
+                printf "  >>> continue / list errors / kill palmbuild (c/l/k) ? "
+                read  answer
+                if [[ "$answer" = l ]]
+                then
+                   more ${configuration_identifier}_last_make_protocol
+                fi
+             done
+             if [[ $answer = k ]]
+             then
+                locat=user_abort; exit
+             fi
+          else
+             # ABORT ANYWAY
+             locat=user_abort; exit
+          fi
+       else
+          cp agent_preprocessing $source_path/../SCRIPTS/.
+       fi
 
 
@@ -789,5 +816,5 @@
        make  $make_options  PROG=$program_name  F90=$compiler_name  COPT="$cpp_options"  F90FLAGS="$compiler_options"  LDFLAGS="$linker_options"  2>&1 | tee ${configuration_identifier}_last_make_protocol
 
-       if [[ $? != 0 ]]
+       if [[ ${PIPESTATUS[0]} != 0 ]]
        then
           printf "\a\n  +++ error(s) occurred during compiling or linking for host configuration \"$configuration_identifier\" "
@@ -885,5 +912,5 @@
           make  $make_options  PROG=$program_name  F90=$compiler_name  COPT="$cpp_options"  F90FLAGS="$compiler_options"  LDFLAGS="$linker_options"
 
-          if [[ $? != 0 ]]
+          if [[ ${PIPESTATUS[0]} != 0 ]]
           then
 
Index: palm/trunk/SCRIPTS/palmrun
===================================================================
--- palm/trunk/SCRIPTS/palmrun	(revision 3311)
+++ palm/trunk/SCRIPTS/palmrun	(revision 3312)
@@ -263,16 +263,20 @@
           done
           [[ $delete_temporary_catalog = true ]]  &&  (cd; rm -rf $tempdir)
-          printf "\n\n+++ palmrun killed \n\n"
-       elif [[ $locat != control_c ]]
-       then
+          printf "\n\n+++ palmrun crashed \n\n"
+          exit 1
+       elif [[ $locat != normal ]]
+       then
+          [[ $delete_temporary_catalog = true ]]  &&  (cd; rm -rf $tempdir)
+          printf "\n+++ palmrun killed by \"^C\" \n\n"
+          exit 2
+       else
           printf "\n --> palmrun finished\n\n"
+          exit 0
        fi' exit
 
 
     # ACTIONS IN CASE OF TERMINAL-BREAK (CONTROL-C):
- trap 'cd; rm -rf $tempdir
-       printf "\n+++ palmrun killed by \"^C\" \n\n"
-       locat=control_c
-       exit
+ trap 'locat=control_c
+       exit 1
       ' 2
 
@@ -1861,5 +1865,5 @@
        fi
 
-       if [[ $? != 0 ]]
+       if [[ ${PIPESTATUS[0]} != 0 ]]
        then
    
@@ -1877,5 +1881,5 @@
     palmbuild  -v  $use_existing_sources_folder  -h $configuration_identifier  -d $run_identifier
 
-    if [[ $? != 0 ]]
+    if [[ ${PIPESTATUS[0]} != 0 ]]
     then
 
@@ -2231,5 +2235,5 @@
     $execute_command  <  coupling_steering
 
-    if [[ $? != 0 ]]
+    if [[ ${PIPESTATUS[0]} != 0 ]]
     then
 
@@ -2542,5 +2546,5 @@
                    batch_scp $PORTOPT $catalog_option $append_option -b -m $usecycle_option -u $local_username $return_address  ${localout[$i]} "${pathout[$i]}" ${configuration_identifier}_${run_identifier}${endout[$i]}  ${extout[$i]}
                 fi
-                [[ $? != 0 ]]  &&  transfer_failed=true
+                [[ ${PIPESTATUS[0]} != 0 ]]  &&  transfer_failed=true
 
 
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 3311)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 3312)
@@ -824,6 +824,7 @@
 !
 !-- Check for overlap combinations, which are not realized yet
-    IF ( transpose_compute_overlap )  THEN
-       IF ( numprocs == 1 )  STOP '+++ transpose-compute-overlap not implemented for single PE runs'
+    IF ( transpose_compute_overlap  .AND. numprocs == 1 )  THEN
+          message_string = 'transpose-compute-overlap not implemented for single PE runs'
+          CALL message( 'check_parameters', 'PA0000', 1, 2, 0, 6, 0 )
     ENDIF
 
Index: palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3311)
+++ palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3312)
@@ -1078,7 +1078,6 @@
                                  ' are not the ones required by PALM-4U: please check '      // &
                                  ' chemistry emission module documentation.'                                 
-                CALL message( 'chem_emissions_setup', 'CM0446', 2, 2, 0, 6, 0 ) 
-
-                STOP
+                CALL message( 'chem_emissions_setup', 'CM0446', 2, 2, 0, 6, 0 )
+
           END SELECT
 
Index: palm/trunk/SOURCE/local_stop.f90
===================================================================
--- palm/trunk/SOURCE/local_stop.f90	(revision 3311)
+++ palm/trunk/SOURCE/local_stop.f90	(revision 3312)
@@ -101,5 +101,5 @@
           IF ( abort_mode == 1 )  THEN
              CALL MPI_FINALIZE( ierr )
-             STOP ''
+             STOP 1
           ELSEIF ( abort_mode == 2 )  THEN
              CALL MPI_ABORT( comm2d, 9999, ierr )
@@ -140,5 +140,5 @@
              ENDIF
              CALL MPI_FINALIZE( ierr )
-             STOP ''
+             STOP 1
 
           CASE ( 1 )
@@ -149,5 +149,5 @@
              ENDIF
              CALL MPI_FINALIZE( ierr )
-             STOP ''
+             STOP 1
 
           CASE ( 2 )
@@ -195,5 +195,5 @@
 #else
 
-    STOP ''
+    STOP 1
 
 #endif