Index: palm/trunk/SCRIPTS/palmrun
===================================================================
--- palm/trunk/SCRIPTS/palmrun	(revision 3312)
+++ palm/trunk/SCRIPTS/palmrun	(revision 3313)
@@ -230,4 +230,5 @@
  remote_username=""
  running_in_batch_mode=false
+ running_in_test_mode=false
  run_coupled_model=false
  run_id=""
@@ -284,5 +285,5 @@
     # READ SHELLSCRIPT-OPTIONS AND REBUILD THE PALMRUN-COMMAND STRING (prc),
     # WHICH WILL BE USED TO START RESTART-JOBS
- while  getopts  :a:A:bBCd:FG:h:i:jkm:M:O:q:R:s:t:T:u:U:vVw:W:xX:yY:Z option
+ while  getopts  :a:A:bBCd:FG:h:i:jkm:M:O:q:R:s:t:T:u:U:vVw:W:xX:yY:zZ option
  do
    case  $option  in
@@ -317,4 +318,5 @@
        (y)   ocean_file_appendix=true; prc="$prc -y";;
        (Y)   run_coupled_model=true; coupled_dist=$OPTARG; prc="$prc -Y'$OPTARG'";;
+       (z)   running_in_test_mode=true;;
        (Z)   combine_plot_fields=false; prc="$prc -Z";;
        (\?)  printf "\n  +++ unknown option $OPTARG \n"
@@ -2141,4 +2143,13 @@
 
 
+    # CHECK IF THE PROGRESS BAR NEEDS TO BE DISABLED
+    if [[ $running_in_batch_mode = true  ||  $running_in_test_mode = true ]]
+    then
+       progress_bar_disabled=true
+    else
+       progress_bar_disabled=false
+    fi
+
+
        # CREATE THE NAMELIST-FILE WITH VALUES OF ENVIRONMENT-VARIABLES REQUIRED BY PALM
        # (FILE ENVPAR WILL BE READ BY PALM)
@@ -2150,5 +2161,5 @@
           maximum_cpu_time_allowed = ${cpumax}.,
           revision = '$global_revision',
-          batch_job = .${running_in_batch_mode}. /
+          progress_bar_disabled = .${progress_bar_disabled}. /
 
 EOF
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 3312)
+++ palm/trunk/SOURCE/parin.f90	(revision 3313)
@@ -307,5 +307,5 @@
 ! 
 ! 1402 2014-05-09 14:25:13Z raasch
-! location messages modified, batch_job included in envpar-NAMELIST
+! location messages modified, progress_bar_disabled included in envpar-NAMELIST
 ! 
 ! 1384 2014-05-02 14:31:06Z raasch
@@ -495,5 +495,5 @@
 
     USE progress_bar,                                                          &
-        ONLY :  batch_job
+        ONLY :  progress_bar_disabled
 
     USE radiation_model_mod,                                                   &
@@ -722,5 +722,5 @@
              termination_time_needed, vnest_start_time
 
-    NAMELIST /envpar/  batch_job, host, local_dvrserver_running,               &
+    NAMELIST /envpar/  progress_bar_disabled, host, local_dvrserver_running,   &
                        maximum_cpu_time_allowed, maximum_parallel_io_streams,  &
                        read_svf, revision, run_identifier, tasks_per_node,     &
Index: palm/trunk/SOURCE/progress_bar_mod.f90
===================================================================
--- palm/trunk/SOURCE/progress_bar_mod.f90	(revision 3312)
+++ palm/trunk/SOURCE/progress_bar_mod.f90	(revision 3313)
@@ -80,5 +80,5 @@
 
     PRIVATE
-    PUBLIC   batch_job, finish_progress_bar, output_progress_bar
+    PUBLIC   progress_bar_disabled, finish_progress_bar, output_progress_bar
 
     CHARACTER(LEN=60) ::  bar      !< progress bar, initially filled with "_"
@@ -87,5 +87,5 @@
     INTEGER(iwp) ::  ilength !< length of progress bar filled with "X"
 
-    LOGICAL ::  batch_job = .FALSE.   !< switch to determine the run mode
+    LOGICAL ::  progress_bar_disabled = .FALSE.   !< envpar-Namelist switch
 
     REAL(wp) ::  time_to_be_simulated !< in sec
@@ -121,5 +121,5 @@
        ENDIF
 
-       IF ( batch_job )  THEN
+       IF ( progress_bar_disabled )  THEN
 
           CALL check_open ( 117 )
@@ -183,5 +183,5 @@
 !
 !--    In batch mode, use a file (PROGRESS), otherwise use progress bar
-       IF ( batch_job )  THEN
+       IF ( progress_bar_disabled )  THEN
 
           BACKSPACE ( 117 )
@@ -226,5 +226,5 @@
        IMPLICIT NONE
 
-       IF ( batch_job )  THEN
+       IF ( progress_bar_disabled )  THEN
 
           CALL close_file ( 117 )